' Name des Autopilots
AIName = "Thunders Rowdy"

' Intelligenz des Autopilots
' pRobot ist der Roboter
'	Ihr drft nicht auf die Felder von pRobot zugreifen!
'	pRobot wird lediglich verwendet als Parameter fr die Funktionen
'	GetV1, GetV2, AccelerateRobot und AccelerateRobotTo
' pDists ein Array mit den Distanzen der Sensoren
'	Das Array ist SENSORS_VIS_CNT gross, resp 2 * SENSORS_PER_SIDE + 1
'	Index 0 ist der Sensor, der ganz nach rechts zeigt
'	Index SENSORS_PER_SIDE zeigt geradeaus
'	Index SENSORS_VIS_CNT - 1 zeigt nach links
'	Die Distanz ist in Einheiten angeben (1 Einheit = 1 Tile)
Function AutoPilotRobot(pRobot:TRobot, pDists#[])
	Local sum#, lsum#, rsum#, i%, j%, c#[]=pdists[..], m# = 50000, lv#, rv#, mx#, d#, ld#, rd#, g#

	' Gleichanteil aus dem Array entfernen (maximum ber die gesamte zeitdauer)
	For i = 0 Until SENSORS_VIS_CNT
		If c[i] < m Then m = c[i]
	Next
	For i = 0 Until SENSORS_VIS_CNT
		c[i] :- m
	Next
	
	' linke und rechte seite der sensoren integrieren mit gewicht
	g=1
	For i = -SENSORS_PER_SIDE To SENSORS_PER_SIDE
		g = Log10(SENSORS_PER_SIDE+1-Abs(i)) ' experimentell gefunden, bringt ca 6 zehntel sekunden
		If i < 0 Then rsum :+ c[SENSORS_PER_SIDE+i]*g
		If i > 0 Then lsum :+ c[SENSORS_PER_SIDE+i]*g
		sum :+ c[SENSORS_PER_SIDE+i]
	Next

	' Geschwindigkeit berechnen
	g=lsum/(lsum+rsum)
	'g=1-Cos(90*lsum/(lsum+rsum))
	mx = MAX_VEL
	lv# = mx*g
	rv# = mx*(1-g)

	' geschwindigkeiten der rder normalisieren
	ld = mx-lv
	rd = mx-rv
	
	If ld < rd And ld > 0 Then
		lv = mx
		rv :+ ld
	ElseIf rd > 0 Then
		lv :+ rd
		rv = mx
	EndIf
	
	'Print pos_x+" "+pos_y
	' Steuern
	' Zum Steuern stehen euch diese beiden Funktionen zur Verfgung
	' - AccelerateRobot(pRobot, pAcc1#, pAcc2#)
	'	Beschleunigt die Rder um die angegebenen Werte. Die Beschleunigung wird
	'	von der Simulation beschrnkt auf MAX_ACC, hhere Werte werden begrenzt.
	' - AccelerateRobotTo(pRobot, pVel1#, pVel2#)
	'	Beschleunigt die Rder mit Maximalbeschleunigung auf die angegebenen Ziel-
	'	geschwindigkeiten. Die Geschwindigkeit wird von der Simulation beschrnkt
	'	auf MAX_VEL, hhere Werte werden begrenzt.
	AccelerateRobotTo(pRobot, lv, rv)
End Function

