' Men zeichnen
Function DrawMenu(pSandbox:TSandbox, pFont:TSimpFont)
	' Men-Interaktion (ESC)
	If KeyHit(KEY_ESCAPE) then
		' Whrend der Simulation: Men ffnen
		If state = STATE_SIMULATION then
			state = STATE_PAUSE
		' Whrend dem Men: Spiel beenden
		Else
			End
		EndIf
	EndIf
	' Wenn Men geffnet ist
	If state = STATE_MENU Or state = STATE_PAUSE then
		' Steuerungs-Auswahl
		Local label$
		If controls = CONTROLS_HUMAN then
			label = "Manuell"
		Else	
			label = AIName
		EndIf
		If DrawButton("Steuerung: " +label, TILE_SIZE *2, pFont) then
			controls = 1 -controls
		EndIf
		' Spiel beenden Schaltflche
		If DrawButton("Beenden", TILE_SIZE *9, pFont) then
			End
		EndIf
	EndIf
	' Im Hauptmen (zu Beginn)
	If state = STATE_MENU then
		' Spiel starten Schaltflche
		If DrawButton("Simulation starten", TILE_SIZE *7, pFont) then
			ResetSandbox(pSandbox)
			state = STATE_SIMULATION
			MoveMouse(SCREEN_WIDTH /2, SCREEN_HEIGHT /2)
		EndIf
	' Im Pausemen
	ElseIf state = STATE_PAUSE then
		' Spiel fortsetzen Schaltflche
		If DrawButton("Simulation fortsetzen", TILE_SIZE *5, pFont) then
			state = STATE_SIMULATION
			MoveMouse(SCREEN_WIDTH /2, SCREEN_HEIGHT /2)
		EndIf
		' Spiel neustarten Schaltflche
		If DrawButton("Simulation neustarten", TILE_SIZE *7, pFont) then
			ResetSandbox(pSandbox)
			state = STATE_SIMULATION
			MoveMouse(SCREEN_WIDTH /2, SCREEN_HEIGHT /2)
		EndIf
	EndIf
End Function

' Schaltflche zeichnen
Function DrawButton%(pText$, pY%, pFont:TSimpFont)
	Local hover% = False
	Local x% = (TILES_X * TILE_SIZE) *0
	Local y% = pY - TILE_SIZE *1
	Local w% = (TILES_X * TILE_SIZE) *1
	Local h% = TILE_SIZE *2
	' Maus ber Schaltflche?
	If mx >= x And mx < (x+w) And my >= y And my < (y+h) then
		hover = True
	EndIf
	' Highlight
	If hover then
		SetColor(96,96,96)
		DrawRect(x, y, w, h)
	EndIf
	' Schaltflchen-Text
	SetColor(255,255,255)
	DrawSimpText(pFont, pText, x +w/2, y +h/4 +2, ALIGN_CENTER)
	' Schaltflche bettigt?
	If hover = True And mh1 = True then
		Return True
	EndIf
	Return False
End Function
